Attribute VB_Name = "MWVersion"
Option Explicit
'Original code for win versioning from Microsoft
'Original code for Dos from Softweng (http://www.codeguru.com/forum/showthread.php?s=&postid=72594#post72594)

Public Type OSVERSIONINFO
   dwOSVersionInfoSize As Long
   dwMajorVersion As Long
   dwMinorVersion As Long
   dwBuildNumber As Long
   dwPlatformId As Long
   szCSDVersion As String * 128
End Type

'//public Constants
Public Const NORMAL_PRIORITY_CLASS = &H20&
Public Const INFINITE = -1&
   
'//public Types
Public Type STARTUPINFO
   cb As Long
   lpReserved As String
   lpDesktop As String
   lpTitle As String
   dwX As Long
   dwY As Long
   dwXSize As Long
   dwYSize As Long
   dwXCountChars As Long
   dwYCountChars As Long
   dwFillAttribute As Long
   dwFlags As Long
   wShowWindow As Integer
   cbReserved2 As Integer
   lpReserved2 As Long
   hStdInput As Long
   hStdOutput As Long
   hStdError As Long
End Type
   
Public Type PROCESS_INFORMATION
   hProcess As Long
   hThread As Long
   dwProcessID As Long
   dwThreadID As Long
End Type

Public Declare Function GetVersionExA Lib "kernel32" _
               (lpVersionInformation As OSVERSIONINFO) As Integer
 

   
'//API Declarations
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal _
   hHandle As Long, ByVal dwMilliseconds As Long) As Long
   
Public Declare Function CreateProcessA Lib "kernel32" (ByVal _
   lpApplicationName As Long, ByVal lpCommandLine As String, ByVal _
   lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, _
   ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, _
   ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, _
   lpStartupInfo As STARTUPINFO, lpProcessInformation As _
   PROCESS_INFORMATION) As Long
   
Public Declare Function CloseHandle Lib "kernel32" (ByVal _
   hObject As Long) As Long

Public Function getVersion() As String
       Dim osinfo As OSVERSIONINFO
       Dim retvalue As Integer

       osinfo.dwOSVersionInfoSize = 148
       osinfo.szCSDVersion = Space$(128)
       retvalue = GetVersionExA(osinfo)

       With osinfo
       Select Case .dwPlatformId

        Case 1
        
            Select Case .dwMinorVersion
                Case 0
                    getVersion = "Windows 95"
                Case 10
                    getVersion = "Windows 98"
                Case 90
                    getVersion = "Windows Mellinnium"
            End Select

        Case 2
            Select Case .dwMajorVersion
                Case 3
                    getVersion = "Windows NT 3.51"
                Case 4
                    getVersion = "Windows NT 4.0"
                Case 5
                    If .dwMinorVersion = 0 Then
                        getVersion = "Windows 2000"
                    Else
                        getVersion = "Windows XP"
                    End If
            End Select

        Case Else
           getVersion = "Failed"
    End Select

       End With
End Function



